/**
 * Test a high character to make sure signedness 
 * isn't messing us up.
 */

#include <stdio.h>
#include <stdlib.h>


%% High
	# We Want the header portion.
	struct { };
	alphtype unsigned int;

	main = *( 
			0x20  .. 0xefffffff :{printf("gothigh1\n");} | 
			0xf0000000          :{printf("gothigh1\n");} | 
			0x200 .. 0xfe000000 :{printf("gothigh2\n");} |
			any :-1 :{printf("else\n");}
		);
%%

High high;

#define BUFSIZE 1024
char cbuf[BUFSIZE];
unsigned int buf[BUFSIZE];
int buflen = 0;
char numbuf[9];
int numlen = 0;


%% Tokenizer
	struct { };

	func bufdigit {
		if ( numlen < 8 )
			numbuf[numlen++] = *p;
	}

	func writeDigit {
		/* Null terminate the buffer storing the number and reset. */
		numbuf[numlen] = 0;
		numlen = 0;

		/* Store the number in the buf. If the buf is full then 
		 * flush and reset the buffer. */
		buf[buflen++] = strtoul( numbuf, 0, 16 );
		if ( buflen == BUFSIZE ) {
			HighExecute( &high, buf, BUFSIZE );
			buflen = 0;
		}
	}

	func finish {
		if ( buflen > 0 )
			HighExecute( &high, buf, buflen );
		HighFinish( &high );
		if ( HighAccept( &high ) )
			printf("ACCEPT\n");
		else
			printf("FAIL\n");
	}

	num = +( digit | 'a'..'f' ) $bufdigit %writeDigit;
	main = *( num %-1 | space ) %finish;
%%

Tokenizer tok;


int main()
{
	HighInit( &high );
	TokenizerInit( &tok );

	while ( 1 ) {
		int len = fread( cbuf, 1, BUFSIZE, stdin );
		TokenizerExecute( &tok, cbuf, len );
		if ( len != BUFSIZE )
			break;
	}
	TokenizerFinish( &tok );
	if ( ! TokenizerAccept( &tok ) )
		printf("Tokenizer FAIL\n");

	
	return 0;
}

